
local C = require("classic")
local M = require("menu")

function menu_item_exists(id)
   for k,v in ipairs(kts.MENU.items) do
      if v.id == id then
         return true
      end
   end
   return false
end

function add_menu_item_after(item_id, old_id)
   if menu_item_exists(old_id) then
      local pos
      for k,v in ipairs(kts.MENU.items) do
         if v.id == old_id then
            pos = k
            break
         end
      end
      table.insert(kts.MENU.items, pos+1, item_id) -- Add after the specified choice
   else
      table.insert(kts.MENU.items, item_id)  -- Add it at the end.
   end
end


function add_spiders(num)
   local count_table = { }
   -- Initialize the table of spider counts first
   for i=1, #spiders do
      table.insert(count_table, 0)
   end
   -- Increase the counts of random types of spiders
   for i=1, num do
      local j = kts.RandomRange(1, #spider_chances)
      local k = spider_chances[j]
      count_table[k] = (count_table[k]) + 1
   end
   -- And then finally add the monsters to the dungeon table
   for i=1, #spiders do
      C.add_initial_monsters(spiders[i], count_table[i])
      C.add_monster_limit   (spiders[i], count_table[i])
   end

   -- Add spiders to barrels!
   C.t_barrel.on_destroy = function()
      C.destroy4()
      if kts.RandomChance(0.3) then
         if kts.RandomChance(0.3) then
            kts.AddMonster(cxt.pos, m_spider2)
         else
            kts.AddMonster(cxt.pos, m_spider1)
         end
      end 
   end   
end

-- Menu item for spiders

-- M.add_menu_item("spacer")

spiders_item = { 
   id = "spiders",
   text = "Spiders",
   choice_min = 0,
   choice_max = 5,
   features = function(S)
   -- Add Spiders in the dungeon initially
      local num_spiders = 0
      if S.spiders > 0 then
         num_spiders = 2 * S.spiders + 1
         add_spiders(num_spiders) 
      end
   end
}

add_menu_item_after(spiders_item, "bats")
